module Main where

import Animation hiding (planets, translate)
import Picture 

-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
----                             PROBLEM 1                              -----
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

data XML =                                             
         PCDATA  String                                                     
       | Element ElementName [Attribute] [XML]

type ElementName = String                                                    
type Attribute = (String,String)

xml = Element "A" [] 
         [PCDATA "data1",
          Element "B" [("a1","v1"),("a2","v2")] [PCDATA "moredata"], 
          PCDATA "data2",
          PCDATA "data3",
          Element "C" [("a3","v3")] [],
          PCDATA "data4"]

-- Replace with your solution:
instance Show XML where
  showsPrec _ _ = showString "XML"


-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
----                             PROBLEM 2                              -----
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

---------------------
-- Utility functions:
---------------------

-- Translate a picture by a given vector
translate :: (Float,Float) -> Picture -> Picture
translate v p =
    case p of
      Region c r -> Region c (Translate v r)
      RegionC c r -> RegionC c (Translate v r)
      p1 `Over` p2 -> (translate v p1) `Over` (translate v p2)
      EmptyPic -> EmptyPic

-- Translate a picture behavior by a given vector behavior
translateB :: (Behavior Float, Behavior Float) 
           -> Behavior Picture 
           -> Behavior Picture
translateB (x,y) p = lift2 translate (zipB (x,y)) p

-- Convert a pair of behaviors into a pair behavior
zipB :: (Behavior a, Behavior b) -> Behavior (a,b)
zipB (Beh b1, Beh b2) = Beh (\t -> (b1 t, b2 t))

-- Construct a circle behavior
circ :: Behavior Float -> Behavior Shape
circ r = ell r r

---------------
-- Solar system
---------------

sun :: Behavior Picture
sun = reg (lift0 Yellow) (shape (circ 1))

-- Replace the right-hand side of this definition by your solar system
planets :: Behavior Picture
planets = sun

-----------------------------------------------------------------------------

-- Do not change this definition:
main :: IO()
main = 
  do print xml
     animateB "Solar system" planets


-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
----                             PROBLEM 3                              -----
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

{- 

If you choose to answer this part, either put your answer in a comment
here or email a separate PDF file.

-}


